using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.FcBusinesses.Bills;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses
{
    public interface IFcInboundBillRepository
    {
        Task<BaseResult> Add(FcInboundBillElastic FcInboundBill);
        Task<BaseResult> AddManyAsync(IEnumerable<FcInboundBillElastic> FcInboundBills);
        Task<BulkResponse> DeleteFcInboundBills(IEnumerable<FcInboundBillElastic> FcInboundBills);
        Task<DeleteByQueryResponse> DeleteFcInboundBillsByQuery(IEnumerable<long> ids);
        Task<SmartTableResult<FcInboundBillElastic>> SearchForExcel(BoolQueryDescriptor<FcInboundBillElastic> query);
        Task<SmartTableResult<FcInboundBillElastic>> GetByIds(List<long> ids);

    }
    public class FcInboundBillRepository : IFcInboundBillRepository
    {
        private readonly ElasticIndex<FcInboundBillElastic> _dbContext;

        public FcInboundBillRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<FcInboundBillElastic>(settings.Value.ClusterUrl, "fcinboundbill");
        }

        #region  search

        public async Task<SmartTableResult<FcInboundBillElastic>> SearchForExcel(BoolQueryDescriptor<FcInboundBillElastic> query)
        {
            return await _dbContext.Search(query);
        }

        #endregion

        #region Add order

        public async Task<BaseResult> Add(FcInboundBillElastic FcInboundBill)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(FcInboundBill);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<FcInboundBillElastic> FcInboundBills)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(FcInboundBills);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<BulkResponse> DeleteFcInboundBills(IEnumerable<FcInboundBillElastic> FcInboundBills)
        {
            return await _dbContext.DeleteMany(FcInboundBills);
        }

        public async Task<DeleteByQueryResponse> DeleteFcInboundBillsByQuery(IEnumerable<long> ids)
        {
            return await _dbContext.DeleteByIds(ids);
        }

        public async Task<SmartTableResult<FcInboundBillElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<FcInboundBillElastic>();
            var idsQ = new QueryContainerDescriptor<FcInboundBillElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        #endregion
    }
}
